
// ----------------------------------------------------------------------

void eyesBlink() {
  // does blink eye sequences
  NE = eyeMode + 1;
  switch(eyeMode) {
    case -1: break; // default state, do nothing
    case 0:
      // eyes are off
      eyeIntLft = 0; eyeIntRht = 0; eyeDelRst = 15; eyeMode = -1; break;
      
    // open right eye and blink
    case 100: 
      skullMode = 100;
      eyeIntLftTrg = 0; eyeIntRhtTrg = 0;
      Set_Eye_Sweep(20,0); Set_Eye_Swp_Wait(NE); break;
    case 101: Set_Eye_Wait(10,NE); break;
    case 102: eyeIntRht= 0; Set_Eye_Wait(10,NE); break; // blink
    case 103: eyeIntRht= 20;Set_Eye_Wait(10,NE); break;
    case 104: Set_Eye_Sweep(0,0); Set_Eye_Swp_Wait(NE); break;
    case 105: eyeMode = 0; break;
      
    // open left eye and blink
    case 200:
      skullMode = 200;
      eyeIntLftTrg = 0; eyeIntRhtTrg = 0;
      Set_Eye_Sweep(0,20); Set_Eye_Swp_Wait(NE); break;
    case 201: Set_Eye_Wait(10,NE); break;
    case 202: eyeIntLft= 0; Set_Eye_Wait(10,NE); break; // blink
    case 203: eyeIntLft= 20;Set_Eye_Wait(10,NE); break;
    case 204: Set_Eye_Sweep(0,0); Set_Eye_Swp_Wait(NE); break;
    case 205: eyeMode = 0; break;
      
    // open both eyes and blink
    case 300: 
      skullMode = 300;
      eyeIntLftTrg = 0; eyeIntRhtTrg = 0;
      Set_Eye_Sweep(20,20); Set_Eye_Swp_Wait(NE); break;
    case 301: eyeIntRht= 100; eyeIntLft= 100; eyeMode++; break;
    case 302: Set_Eye_Wait(100,NE); break;
    case 303: eyeIntRht= 0; eyeIntLft= 0; Set_Eye_Wait(10,NE); break; // blink
    case 304: eyeIntRht= 20; eyeIntLft= 20; Set_Eye_Wait(10,NE); break;
    case 305: Set_Eye_Sweep(0,0); Set_Eye_Swp_Wait(NE); break;
    case 306: eyeMode = 0; break;

    case 998:
      // wait for eye sweep to end
      if (eyeSweep < 1) {eyeMode = eyeModeLast;}
      break;
    case 999:
      // skip a cycle or several depending on eyeCnt
      eyeCnt--; if (eyeCnt < 1) {eyeMode = eyeModeLast;}
      break;
  }
}

// ----------------------------------------------------------------------

void eyeIntSweep() {
  // adjust eye brightnesses towards target values
  eyeDel--;
  if (eyeDel < 1) {
    eyeDel = eyeDelRst; // reset timer
    eyeSweep = 0; // clear sweep flag as default
    if (eyeIntLft < eyeIntLftTrg) {eyeIntLft++; eyeSweep = 1;}
    if (eyeIntLft > eyeIntLftTrg) {eyeIntLft--; eyeSweep = 1;}
    if (eyeIntRht < eyeIntRhtTrg) {eyeIntRht++; eyeSweep = 1;}
    if (eyeIntRht > eyeIntRhtTrg) {eyeIntRht--; eyeSweep = 1;}
  }
}

// ----------------------------------------------------------------------

void eyeWait(int zCnt) {
  // set up the wait function in the eyeBlink routines
  eyeCnt = zCnt; eyeModeLast = eyeMode; eyeMode = 99;
}

// ----------------------------------------------------------------------

void ledColSweep() {
  // change LED colours towards target values
  ledSweep = 0; // set default state
  if (ledRed0 < ledRedT0) {ledRed0++; ledSweep = 1;}
  if (ledRed0 > ledRedT0) {ledRed0--; ledSweep = 1;}
  if (ledGrn0 < ledGrnT0) {ledGrn0++; ledSweep = 1;}
  if (ledGrn0 > ledGrnT0) {ledGrn0--; ledSweep = 1;}
  if (ledBlu0 < ledBluT0) {ledBlu0++; ledSweep = 1;}
  if (ledBlu0 > ledBluT0) {ledBlu0--; ledSweep = 1;}

  if (ledRed1 < ledRedT1) {ledRed1++; ledSweep = 1;}
  if (ledRed1 > ledRedT1) {ledRed1--; ledSweep = 1;}
  if (ledGrn1 < ledGrnT1) {ledGrn1++; ledSweep = 1;}
  if (ledGrn1 > ledGrnT1) {ledGrn1--; ledSweep = 1;}
  if (ledBlu1 < ledBluT1) {ledBlu1++; ledSweep = 1;}
  if (ledBlu1 > ledBluT1) {ledBlu1--; ledSweep = 1;}

  if (ledRed2 < ledRedT2) {ledRed2++; ledSweep = 1;}
  if (ledRed2 > ledRedT2) {ledRed2--; ledSweep = 1;}
  if (ledGrn2 < ledGrnT2) {ledGrn2++; ledSweep = 1;}
  if (ledGrn2 > ledGrnT2) {ledGrn2--; ledSweep = 1;}
  if (ledBlu2 < ledBluT2) {ledBlu2++; ledSweep = 1;}
  if (ledBlu2 > ledBluT2) {ledBlu2--; ledSweep = 1;}
}

// ----------------------------------------------------------------------

void ledSeq() {
  // sequence the RGB LEDs
  int zledInt, zledBlu, zledGrn, zledRed;
  ledCnt0--;
  if (ledCnt0 < 1) {
    // top left RGB LED
    ledCnt0 = 3 + random(20);  
    zledInt = 2 + random(11); 
    zledRed = map(zledInt,0,12,0,ledRed0);
    zledGrn = map(zledInt,0,12,0,ledGrn0);
    zledBlu = map(zledInt,0,12,0,ledBlu0);
    setPixiCol(0,zledRed, zledGrn, zledBlu);
  }
  ledCnt1--;
  if (ledCnt1 < 1) {
    // top right RGB LED
    ledCnt1 = 3 + random(20);  
    zledInt = 2 + random(11); 
    zledRed = map(zledInt,0,12,0,ledRed1);
    zledGrn = map(zledInt,0,12,0,ledGrn1);
    zledBlu = map(zledInt,0,12,0,ledBlu1);
    setPixiCol(1,zledRed, zledGrn, zledBlu);
  }
  ledCnt2--;
  if (ledCnt2 < 1) {
    // bottom RGB LED
    ledCnt2 = 3 + random(20);  
    zledInt = 5 + random(6); 
    zledRed = map(zledInt,0,13,0,ledRed2);
    zledGrn = map(zledInt,0,13,0,ledGrn2);
    zledBlu = map(zledInt,0,13,0,ledBlu2);
    setPixiCol(2,zledRed, zledGrn, zledBlu);
  }
}

// ----------------------------------------------------------------------

void servoOFF() {
  // detach servo and set flag
  skullServo.detach(); servoEn = 0;
}

// ----------------------------------------------------------------------

void servoON () {
  // attach servo and move it to skullAngle
  skullServo.attach(servoPin);  // attaches skull servo to pin 6
  skullServo.writeMicroseconds(skullAngle); servoEn = 1;
}

// ----------------------------------------------------------------------

void Set_Eye_Sweep(int zR, int zL) {
  // initiate a eye brightness sweep
  eyeIntLftTrg = zL; eyeIntRhtTrg = zR; eyeSweep = 1;
}

// ----------------------------------------------------------------------

void Set_Eye_Swp_Dwn(int zR, int zL) {
  // initiate a eye brightness sweep down to OFF
  eyeIntLft = zL; eyeIntRht = zR; eyeDelRst = 1;
  eyeIntLftTrg = 0; eyeIntRhtTrg = 0; eyeSweep = 1; eyeDel = 0;
}

// ----------------------------------------------------------------------

void Set_Eye_Swp_Wait(int zNE) {
  // initiate an eyeMode taskl wait until and eye sweep has finished
  eyeModeLast = zNE; eyeMode = 998;
}

// ----------------------------------------------------------------------

void Set_Eye_Wait(int zDel, int zNE) {
  // initiate an eye task delay, in loop periods
  eyeCnt = zDel; eyeModeLast = zNE; eyeMode = 999;
}

// ----------------------------------------------------------------------

void setPixelBlu(uint8_t zVal) {
  // set the pixel 0 Blue colour to zVal
  colBlu[0] = zVal;
  strip.setPixelColor(0,strip.Color(colRed[0], colGrn[0], colBlu[0]));
  strip.show();
}

// ----------------------------------------------------------------------

void setPixelGrn(uint8_t zVal) {
  // set the pixel 0 Green colour to zVal
  colGrn[0] = zVal;
  strip.setPixelColor(0,strip.Color(colRed[0], colGrn[0], colBlu[0]));
  strip.show();
}

// ----------------------------------------------------------------------

void setPixelOFF(){
  // turns OFF all LED values
  setPixiCol(0,0,0,0);
  setPixiCol(1,0,0,0);
  setPixiCol(2,0,0,0);
}

// ----------------------------------------------------------------------

void setPixelRed(uint8_t zVal) {
  // set the pixel 0 Red colour to zVal
  colRed[0] = zVal;
  strip.setPixelColor(0,strip.Color(colRed[0], colGrn[0], colBlu[0]));
  strip.show();
}

// ----------------------------------------------------------------------

void setPixiCol(int zP, uint8_t zRed, uint8_t zGrn, uint8_t zBlu) {
  // set the pixel 0 Red colour to zVal
  colRed[zP] = zRed; colGrn[zP] = zGrn; colBlu[zP] = zBlu;
  strip.setPixelColor(zP,strip.Color(colRed[zP], colGrn[zP], colBlu[zP]));
  strip.show();
}

// ----------------------------------------------------------------------

void skullMove() {
  // moves the skull based on a mode
  NS = skullMode + 1;
  if (skullMode >= 0) {if (servoEn < 1) {servoON();}}
  switch(skullMode) {
    case -1: 
      if (servoEn > 0) {servoOFF();}
      break;

    // swiing skull left-right-left, max sweep
    case 0:
      skullAngle += 4;
      if (skullAngle > servoMax) {
        skullAngle = servoMax; skullMode = 1;
      } skullServo.writeMicroseconds(skullAngle);
      break;
    case 1:
      // default regular right-left sweep
      skullAngle -= 4;
      if (skullAngle < servoMin) {
        skullAngle = servoMin; skullMode = 0;
      } skullServo.writeMicroseconds(skullAngle);
      break;

    // swing skull left-right-left, mediumish sweep
    case 10:
      servoRnd = servoMid + random((servoMax - servoMid)/2); skullMode++;
      skullRate = 1 + random(6); break;
    case 11:
      skullAngle += skullRate;
      if (skullAngle > servoRnd) {
        skullAngle = servoRnd; skullMode = 12;
        servoRnd = servoMid - random((servoMax - servoMid)/2);
      } skullServo.writeMicroseconds(skullAngle); break;
    case 12:
      // default regular right-left sweep
      skullAngle -= skullRate;
      if (skullAngle < servoRnd) {
        skullAngle = servoRnd; skullMode = 10;
      } skullServo.writeMicroseconds(skullAngle); break;

    // tilt skull to the right
    case 100:
      skullAngle += 2;
      if (skullAngle > servoMax) {skullAngle = servoMax; skullMode = NS;}
      skullServo.writeMicroseconds(skullAngle); break;
    case 101:
      skullAngle -= 2;
      if (skullAngle < servoMid) {skullAngle = servoMid; skullMode = -1;}
      skullServo.writeMicroseconds(skullAngle); break;

    // tilt skull to the left
    case 200:
      skullAngle -= 2;
      if (skullAngle < servoMin) {skullAngle = servoMin; skullMode = NS;}
      skullServo.writeMicroseconds(skullAngle); break;
    case 201:
      skullAngle += 2;
      if (skullAngle > servoMid) {skullAngle = servoMid; skullMode = -1;}
      skullServo.writeMicroseconds(skullAngle); break;

    // tilt skull to the right, then to the left
    case 300:
      skullAngle += 4;
      if (skullAngle > servoMax) {skullAngle = servoMax; skullMode = NS;}
      skullServo.writeMicroseconds(skullAngle); break;
    case 301:
      skullAngle -= 4;
      if (skullAngle < servoMin) {skullAngle = servoMin; skullMode = NS;}
      skullServo.writeMicroseconds(skullAngle); break;
    case 302:
      skullAngle += 4;
      if (skullAngle > servoMid) {skullAngle = servoMid; skullMode = -1;}
      skullServo.writeMicroseconds(skullAngle); break;

    // move skull to mid-point then stop movement
    case 900:
      if (skullAngle > (servoMid + 4)) {skullAngle -=4;}
      else if (skullAngle < (servoMid - 4)) {skullAngle +=4;}
      else {skullAngle = servoMid; skullMode = -1;}
      skullServo.writeMicroseconds(skullAngle); break;

    // move skull to mid-point immediately then stop movement
    case 999:
      skullAngle = servoMid; skullMode = -1;
      skullServo.writeMicroseconds(skullAngle);
      break;
    default: break;
  }
}

// ----------------------------------------------------------------------

void Task_Iniiitialise() {
  // set up task called at the beginning
  ledRed0 = 0; ledGrn0 = 0; ledBlu0 = 0;
  ledRed1 = 0; ledGrn1 = 0; ledBlu1 = 0;
  ledRed2 = 254; ledGrn2 = 253; ledBlu2 = 0;
  skullMode = 99;
}

// ----------------------------------------------------------------------

void taskList() {
  // sequence task list, everything is controlled from this function
  int zRnd; 
  NT = Task + 1;
  switch (Task) {
    case 0: Task_Iniiitialise(); Task_Wait(300,1); break;
    case 1: Task = 10; break;

    // wake up sequence
    case 10: Task_Wait((100 + random(200)),NT); break;
    case 11: Task_PumpkinFlameSwpON(); Task_Wait_LED(NT); break;
    case 12: Task_Wait((150 +random(200)),NT); break;
    case 13: Task_PumpkinFlameSwpYel(); Task_Wait_LED(NT); break;
    case 14: Task_Wait((150 +random(200)),NT); break;
    case 15:
      // choose a random colour for the pumpkin lights
      zRnd = random(4);
      if (zRnd == 0) {Task_PumpkinFlameSwpRed();}
      if (zRnd == 1) {Task_PumpkinFlameSwpGrn();}
      if (zRnd == 2) {Task_PumpkinFlameSwpPur();}
      if (zRnd == 3) {Task_PumpkinFlameSwpBlu();}
      Task_Wait_LED(NT); break;
    case 16: Task_Wait((150 +random(200)),NT); break;
    case 17:
      // play a random tune
      if (TuneCnt > 11) {
        Tune = lastTune; while (Tune == lastTune) {Tune = random(8);}
      } else {Tune = TuneCnt;}
      lastTune = Tune; pianoSnd = 0; vibSnd = 0;
      if (TunePlay >= 0) {Tune = TunePlay; lastTune = -1;}  // force a tune
      switch (Tune) {
        case 0: loadTune0(); break;
        case 1: loadTune1(); break;
        case 2: loadTune2(); break;
        case 3: loadTune3(); break;
        case 4: loadTune4(); break;
        case 5: loadTune5(); break;
        case 6: loadTune6(); break;
        case 7: loadTune7(); break;
        case 8: loadTune8(); break;
        case 9: loadTune9(); break;
        case 10: loadTune10(); break;
        case 11: loadTune11(); break;
      } TuneCnt++;
      // randomly swing from left to right
      skullMode = 10; Task_Wait_Tune(NT); break;
    case 18:
      skullMode = 900; // move skull to mid-point
      Task_PumpkinFlameSwpYel(); Task_Wait_LED(NT); break; // go back to yellow
    case 19: Task_Wait((150 +random(200)),NT); break;
    case 20: Task_PumpkinFlameSwpDwn(); Task_Wait_LED(NT); break;
    case 21: Task_Wait((150 +random(200)),NT); break;
    case 22: Task_PumpkinFlameSwpOFF(); Task_Wait_LED(NT); break;
    case 23:
      // set delay for next cycle
      Task_Wait((1000 + random(5000)),1);
      if (MasterMode > 2) {Task_Wait((300 + random(700)),1);} // quicker when no sound or servos
      if (Test > 0) {Task_Wait(300,1);} // in Test mode only wait 3 seconds
      break;

    case 996:
      // waits for tune sequence to end then goes to TaskLast
      if (playPnt == -1) {Task = TaskLast;}
      break;
    case 997:
      // waits for eye sweep sequence to end then goes to TaskLast
      if (eyeMode < 1) {Task = TaskLast;}
      break;
    case 998:
      // waits for LED sweep sequence to end then goes to TaskLast
      if (ledSweep < 1) {Task = TaskLast;}
      break;
    case 999:
      // wait task, counts down timer then goes to TaskLast
      TaskWaitCnt--; if (TaskWaitCnt < 1) {Task = TaskLast;}
      break;
    default: Task = 1; break;
  }
}

// ----------------------------------------------------------------------

void Task_PumpkinFlameSwpBlu() {
  // Set all LED target values for Blue  
  ledRedT0 = 0; ledGrnT0 = 0; ledBluT0 = 255;
  ledRedT1 = 0; ledGrnT1 = 0; ledBluT1 = 255;
  ledRedT2 = 0; ledGrnT2 = 0; ledBluT2 = 255;
  ledSweep = 1;
}

// ----------------------------------------------------------------------

void Task_PumpkinFlameSwpDwn() {
  // Set bottom LED target value for yellow, turn top two OFF  
  ledRedT0 = 0; ledGrnT0 = 0; ledBluT0 = 0;
  ledRedT1 = 0; ledGrnT1 = 0; ledBluT1 = 0;
  ledRedT2 = 255; ledGrnT2 = 255; ledBluT2 = 0;
  ledSweep = 1;
}

// ----------------------------------------------------------------------

void Task_PumpkinFlameSwpGrn() {
  // Set all LED target values for Green  
  ledRedT0 = 0; ledGrnT0 = 255; ledBluT0 = 0;
  ledRedT1 = 0; ledGrnT1 = 255; ledBluT1 = 0;
  ledRedT2 = 0; ledGrnT2 = 255; ledBluT2 = 0;
  ledSweep = 1;
}

// ----------------------------------------------------------------------

void Task_PumpkinFlameSwpOFF() {
  // Set all LED target value to OFF  
  ledRedT0 = 0; ledGrnT0 = 0; ledBluT0 = 0;
  ledRedT1 = 0; ledGrnT1 = 0; ledBluT1 = 0;
  ledRedT2 = 0; ledGrnT2 = 0; ledBluT2 = 0;
  ledSweep = 1;
}

// ----------------------------------------------------------------------

void Task_PumpkinFlameSwpON() {
  // Set bottom LED target value for yellow only, keep top two OFF  
  ledRedT0 = 0; ledGrnT0 = 0; ledBluT0 = 0;
  ledRedT1 = 0; ledGrnT1 = 0; ledBluT1 = 0;
  ledRedT2 = 255; ledGrnT2 = 255; ledBluT2 = 0;
  ledSweep = 1;
}

// ----------------------------------------------------------------------

void Task_PumpkinFlameSwpPur() {
  // Set all LED target values for Purple  
  ledRedT0 = 255; ledGrnT0 = 0; ledBluT0 = 255;
  ledRedT1 = 255; ledGrnT1 = 0; ledBluT1 = 255;
  ledRedT2 = 255; ledGrnT2 = 0; ledBluT2 = 255;
  ledSweep = 1;
}

// ----------------------------------------------------------------------

void Task_PumpkinFlameSwpRed() {
  // Set all LED target values for Red  
  ledRedT0 = 255; ledGrnT0 = 0; ledBluT0 = 0;
  ledRedT1 = 255; ledGrnT1 = 0; ledBluT1 = 0;
  ledRedT2 = 255; ledGrnT2 = 0; ledBluT2 = 0;
  ledSweep = 1;
}

// ----------------------------------------------------------------------

void Task_PumpkinFlameSwpYel() {
  // Set all LED target values for yellow  
  ledRedT0 = 255; ledGrnT0 = 255; ledBluT0 = 0;
  ledRedT1 = 255; ledGrnT1 = 255; ledBluT1 = 0;
  ledRedT2 = 255; ledGrnT2 = 255; ledBluT2 = 0;
  ledSweep = 1;
}

// ----------------------------------------------------------------------

void Task_Wait(int zW, int zT) {
  // set main Task wait in loop cycles
  TaskLast = zT; Task =999; TaskWaitCnt = zW;
}

// ----------------------------------------------------------------------

void Task_Wait_Eyes(int zT) {
  // set a wait for eye sweep to finish delay
  TaskLast = zT; Task =997;
}

// ----------------------------------------------------------------------

void Task_Wait_LED(int zT) {
  // set a wait for LED sweep to finish delay
  TaskLast = zT; Task =998;
}

// ----------------------------------------------------------------------

void Task_Wait_Tune(int zT) {
  // set a wait for LED sweep to finish delay
  TaskLast = zT; Task =996;
}

// ----------------------------------------------------------------------

void testResetState() {
  // check EEPROM and count RESETs
  byte zV0,zV1,zV2; // EEPROM read values 
  zV0 = EEPROM.read(0); zV1 = EEPROM.read(1); zV2 = EEPROM.read(2);
  if ((zV0 != 85) || (zV1 != 170) || (zV2 != 15)) {
      // failed 3 byte test so rewrite values
      Serial.println("Initialising EEPROM...");
      EEPROM.update(0, 85);
      EEPROM.update(1, 170);
      EEPROM.update(2, 15);
      EEPROM.update(3, 0); // reset 'mode' value to zero
  }  else {
    // EEPROM contents is assumed valid
    zV0 = EEPROM.read(3) + 1; // increment 'mode' count
    EEPROM.update(3, zV0);
    Serial.print("Mode = "); Serial.println(zV0);
  }
  // now wait in case of another RESET button press
  // flash LED whilst waiting
  for (zV0 = 0; zV0 < 15; zV0++) {
    digitalWrite(LEDPin, HIGH); delay(100);
    digitalWrite(LEDPin, LOW); delay(100);
  }
  // if we return after this then no further RESETs have occured
}

// ----------------------------------------------------------------------



